local FONTNAME="HEVSUITTEXTH"	//the hevsuit font
surface.CreateFont( "Tahoma", 10 * ( ScrH() / 480.0 ), 1000, true, false, FONTNAME)

local SHOULDPRINTTOCHAT=false;	//should the hev suit print to your local chat the messages?
local SHOULDDRAWUPPERSTRINGS=true;
local PL_COLOR 		=Color(255,220,0,160)//the hev suit chat color
local TalkTimer=CurTime()	//don't touch this
local SpeakTable={}			//not even this
local IsSpeaking_TDS=false;	//not even this
local DamageTable={}		//and this
local TextTable={}			//and this
local ADD_TO_QUEUE=true;	//and this
local DONT_ADD_TO_QUEUE=false;//and this
local RESTORE_AFTER_30_SECONDS=30;//and this
local RESTORE_AFTER_5_MINUTES=300;//and this
//and all of these!
local HEV_MAJOR_FRACTURE=1;
local HEV_MINOR_FRACTURE=2;
local HEV_INTERNAL_BLEEDING=3;
local HEV_BLEEDING_STOPPED=4;
local HEV_BLOOD_LOSS=5;
local HEV_MAJOR_LACERATION=6;
local HEV_MINOR_LACERATION=7;
local HEV_POISON=8;
local HEV_ANTI_TOXIN=9;
local HEV_BIOHAZARD=10;
local HEV_NERVEGAS=11;
local HEV_RADIATION=12;
local HEV_SHOCK=13;
local HEV_HEAT=14;
local HEV_AUTOMEDIC_ON=15;
local HEV_MORPHINE=16;
local HEV_NEARDEATH=17;
local HEV_HEALTH_CRITICAL=18;
local HEV_SEEK_MEDICAL_ATTENTION=19;
//don't touch this
local NUMBERS={}
NUMBERS[1]="hl1fvox/one.wav"
NUMBERS[2]="hl1fvox/two.wav"
NUMBERS[3]="hl1fvox/three.wav"
NUMBERS[4]="hl1fvox/four.wav"
NUMBERS[5]="hl1fvox/five.wav"
NUMBERS[6]="hl1fvox/six.wav"
NUMBERS[7]="hl1fvox/seven.wav"
NUMBERS[8]="hl1fvox/eight.wav"
NUMBERS[9]="hl1fvox/nine.wav"
NUMBERS[10]="hl1fvox/ten.wav"
NUMBERS[11]="hl1fvox/eleven.wav"
NUMBERS[12]="hl1fvox/twelve.wav"
NUMBERS[13]="hl1fvox/thirteen.wav"
NUMBERS[14]="hl1fvox/fourteen.wav"
NUMBERS[15]="hl1fvox/fifteen.wav"
NUMBERS[16]="hl1fvox/sixteen.wav"
NUMBERS[17]="hl1fvox/seventeen.wav"
NUMBERS[18]="hl1fvox/eighteen.wav"
NUMBERS[19]="hl1fvox/nineteen.wav"
NUMBERS[20]="hl1fvox/twenty.wav"
NUMBERS[30]="hl1fvox/thirty.wav"
NUMBERS[40]="hl1fvox/fourty.wav"
NUMBERS[50]="hl1fvox/fifty.wav"
NUMBERS[60]="hl1fvox/sixty.wav"
NUMBERS[70]="hl1fvox/seventy.wav"
NUMBERS[80]="hl1fvox/eighty.wav"
NUMBERS[90]="hl1fvox/ninety.wav"
NUMBERS[100]="hl1fvox/onehundred.wav"
//look,you'd better doun't touch anything,lol
local function HevNumberToTable(number)
	local numbtable={}
	local numbercopy=number;
	if numbercopy<=0 then return {"hl1/fvox/fuzz.wav"} end
	if numbercopy>9000 then return {//VEGETA! WHAT'S HIS POWERLEVEL?
	"vo/npc/male01/question26.wav"  //it's over... this is BULLSHIIIIIIIIIIIIIIIIIIT. 
	}//          :V
	end
	if(numbercopy>100)then //if the number is more than 100,cut 100 from numbercopy and add onehundred to the table
		table.insert(numbtable,NUMBERS[100])
		numbercopy=numbercopy-100
	end 
	if(NUMBERS[numbercopy])then//ehi,our number is inside our NUMBERS table,we don't even need to divide it!
		table.insert(numbtable,NUMBERS[numbercopy])
	else				   //otherwise... we need to divide it per 10 and then add the content to the table
		local numb1 = numbercopy - numbercopy%10 //example: 61, 61-61%10=61-1=60
		local numb2 = math.Round(numbercopy%10)//61%10=1
		table.insert(numbtable,NUMBERS[numb1])//sixty
		table.insert(numbtable,NUMBERS[numb2])//one
	end
	return numbtable;//return teh table to the caller.
end

local function HevNumberToString(number)
	local stringa="Power level is "
	local numbercopy=number;
	if numbercopy<=0 then return stringa.."below zero percent." end
	if numbercopy>9000 then return stringa.."over nine thousands! percent." end
	if(numbercopy>100)then //if the number is more than 100,cut 100 from numbercopy and add onehundred to the table
		stringa=stringa..NUMBERS[100]
		numbercopy=numbercopy-100
	end 
	if(NUMBERS[numbercopy])then//ehi,our number is inside our NUMBERS table,we don't even need to divide it!
		stringa=stringa..NUMBERS[numbercopy]
	else				   //otherwise... we need to divide it per 10 and then add the content to the table
		local numb1 = numbercopy - numbercopy%10 //example: 61, 61-61%10=61-1=60
		local numb2 = math.Round(numbercopy%10)//61%10=1
		stringa=stringa..NUMBERS[numb1]//sixty
		stringa=stringa.." "..NUMBERS[numb2]//one
	end
	stringa=string.Strip(stringa,"hl1fvox/")
	stringa=string.Strip(stringa,".wav")
	
	return stringa.." percent.";//return teh table to the caller.
end
//stripped from TDS,can the client speak?
local function ClientCanSpeak()
		if !TalkTimer then TalkTimer=CurTime() end
		if(TalkTimer<=CurTime())then
			return true;
		else
			return false;
		end
end
//just for debug
function GetDamageTable()
	PrintTable(DamageTable)
end
//just for debug
function GetSpeakTable()
	PrintTable(SpeakTable)
end
//stripped from TDS,add the sound time to the talktimer
local function ClientSpeakDelay(snd)
	TalkTimer=CurTime()+SoundDuration(snd)
end
//get the whole sound time of the table,then return it
local function GetTableDelay(tab)
	local delay=0;
	for i,v in pairs(tab)do
		delay=SoundDuration(v)+delay
	end
	return delay;
end
//stripped from TDS,stop speaking
local function ClientStopSpeaking()
	TalkTimer=CurTime();
	IsSpeaking_TDS=false;
	table.Empty(SpeakTable)
	table.Empty(DamageTable)
	table.Empty(TextTable)

end
//silly function to control if a table has a not-sound-value
local function IsStringSound(stringa)
	if string.find(stringa,".wav") or string.find(stringa,".mp3") then
		return true
	else
		return false
	end
end
//stripped from TDS,and modified to add a text to the TextTable
local function ClientSpeaktable(soundtable,shouldstack)
	if !shouldstack && IsSpeaking_TDS then return end
		table.Add(SpeakTable,soundtable);
		for i,v in pairs(SpeakTable) do
			if !IsStringSound(v) then
			if SHOULDPRINTTOCHAT then
			chat.AddText( PL_COLOR, "HEV: ", Color( 255, 255, 255 ), v )
			chat.PlaySound()
			end
			
			local t={}
				t.Text=v;
				t.Time=CurTime()+GetTableDelay(SpeakTable)//+GetTableDelay(soundtable)
			table.insert(TextTable,t)
			table.remove(SpeakTable,i) 
			end
		end
		IsSpeaking_TDS=true;
end
//stripped from TDS,play the AMMODEPLETED sound when needed to,and speak!
local function CLIENT_Speak_table()
			if(LocalPlayer():Alive() && LocalPlayer():GetActiveWeapon() != NULL )then
				if(LocalPlayer():GetActiveWeapon():Clip1()>0)then
					LocalPlayer().needreload=true;
				elseif(LocalPlayer():GetActiveWeapon():Clip1()==0 && LocalPlayer().needreload==true && LocalPlayer():GetActiveWeapon():GetClass() != "weapon_physcannon")then
					if(LocalPlayer():GetActiveWeapon():Clip1()==0 && LocalPlayer():GetAmmoCount(LocalPlayer():GetActiveWeapon():GetPrimaryAmmoType()) == 0)then
					LocalPlayer().needreload=false;
					ClientSpeaktable(TLK_HEV_AMMODEPLETED,true)
					else
					LocalPlayer().needreload=false;
					end
				end
			end
			
	if !LocalPlayer():Alive() then ClientStopSpeaking() end
	if IsSpeaking_TDS && ClientCanSpeak() then
		if #SpeakTable == 0 then
			IsSpeaking_TDS=false;
		else
			surface.PlaySound(SpeakTable[1])
			ClientSpeakDelay(SpeakTable[1])
			table.remove(SpeakTable, 1 )
		end
	end
end
hook.Add( "Think", "CLIENT_Speak_table", CLIENT_Speak_table )
//stripped from TDS,make the client speak something,but don't let it again if it already spoke that something
//but "seconds" have not passed yet
local function SetSuitUpdate(TABB,message,seconds,bool)
		if !table.HasValue(DamageTable,message) then
			ClientSpeaktable(TABB,bool);
			table.insert(DamageTable,message);
			timer.Simple(seconds, function() 
				if !IsValid(ply)then return end
				for	i,v in pairs (DamageTable) do
					if v==message then table.remove(DamageTable,i)end
				end
			end)
		end
end

//the message is ordered like this:
//HEV_SHOCK = Short,the type of damage
//RESTORE_AFTER_30_SECONDS = Short,seconds after enabling that concept again
//ADD_TO_QUEUE				= Boolean,add to the queue?
local function HEVSUITMESSAGE( um )
	local TYPE=um:ReadShort()
	local TIME=um:ReadShort()
	local ADD =um:ReadBool()
	local TAB={}
	if TYPE==HEV_MAJOR_FRACTURE then TAB=TLK_HEV_DMG5				//major fracture detected
	elseif TYPE==HEV_MINOR_FRACTURE then TAB=TLK_HEV_DMG4			//minor fracture detected
	elseif TYPE==HEV_INTERNAL_BLEEDING then TAB=TLK_HEV_DMG2		//boop boop,internal bleeding
	elseif TYPE==HEV_BLEEDING_STOPPED then TAB=TLK_HEV_HEAL1		//torniquette applied,bleeding bla bla
	elseif TYPE==HEV_BLOOD_LOSS then TAB=TLK_HEV_DMG6				//blood loss detected
	elseif TYPE==HEV_MAJOR_LACERATION then TAB=TLK_HEV_DMG4			//major laceraction detected
	elseif TYPE==HEV_MINOR_LACERATION then TAB=TLK_HEV_DMG0			//minor laceraction detected
	elseif TYPE==HEV_POISON  then TAB=TLK_HEV_DMG3					//warning,blood toxin detected
	elseif TYPE==HEV_ANTI_TOXIN then TAB=TLK_HEV_HEAL4				//anti toxin,adminestred
	elseif TYPE==HEV_BIOHAZARD then TAB=TLK_HEV_DET1				//warning,bio hazard bla bla
	elseif TYPE==HEV_NERVEGAS then TAB=TLK_HEV_DET0					//warning,bla bla	
	elseif TYPE==HEV_RADIATION then TAB=TLK_HEV_DET2				//warning,bla bla
	elseif TYPE==HEV_SHOCK then TAB=TLK_HEV_DMG_SHOCK				//warning,electrical damage detected
	elseif TYPE==HEV_HEAT then TAB=TLK_HEV_DMG_HEAT					//warning,EXTREME HEAT DAMAGE,detected
	elseif TYPE==HEV_AUTOMEDIC_ON then TAB=TLK_HEV_MED1				//automedical system bla bla
	elseif TYPE==HEV_MORPHINE then TAB=TLK_HEV_HEAL7				//hiss,morphine adminestred
	elseif TYPE==HEV_NEARDEATH then TAB=TLK_HEV_HLTH3				//BIP BIP BIP,warning USER DEATH IMMINENT
	elseif TYPE==HEV_HEALTH_CRITICAL then TAB=TLK_HEV_HLTH2			//warning,vital signs critical
	elseif TYPE==HEV_SEEK_MEDICAL_ATTENTION then TAB=TLK_HEV_DMG7	//warning,seek medical attention
	else TAB=TLK_HEV_BELL end										//Belltone!
	SetSuitUpdate(TAB,TYPE,TIME,ADD)
end
usermessage.Hook("hevsuit_damage", HEVSUITMESSAGE)

local function HEVItemPickedUp( ItemName )
	timer.Simple(0.1, function() //i had to put this in a timer because the suit battery does not get acquired instantly.
	if ItemName=="item_battery" then 
		local taba=HevNumberToTable(LocalPlayer():Armor())
		table.insert(taba,1,"hl1/fvox/power_level_is.wav")
		table.insert(taba,1,"hl1/fvox/fuzz.wav")
		table.insert(taba,1,"hl1/fvox/fuzz.wav")
		table.insert(taba,"hl1/fvox/percent.wav")
		taba.TEXT=HevNumberToString(LocalPlayer():Armor())
		ClientSpeaktable(taba,true)
		//fuzz fuzz! power level is fifteen percent
	end
	end)
end
hook.Add( "HUDItemPickedUp", "HEVItemPickedUp", HEVItemPickedUp )
//silly function to get the delay of the speaktable
local function GetTextDelay(f)
	local delay=0;
	for i,v in pairs(SpeakTable) do
		if i < f then
		delay=SoundDuration(v)+delay
		end
	end
	return delay;
end
//if you want to screw with these two variables,you can't since these are dynamic
//to the text in the queue
local BOX_W=300
local BOX_H=100
//screw with these,even tought the POS_Y will be resetted every HUDDraw tick
local POS_X=27
local POS_Y=(ScrH()-BOX_H)-100

local function HevDrawDamageLog()
	//the player is not alive,or his hevsuit log is empty,whatever
	if !LocalPlayer():Alive() || #TextTable == 0 then return end
	local maxf=0;
	local maxb=0;
	for i,v in pairs(TextTable) do
		surface.SetFont(FONTNAME) //this is needed or the getTextSize will screw up.
		if SHOULDDRAWUPPERSTRINGS then v.Text=string.upper(v.Text) end	//look,the user wants everything upper.
		local W,H=surface.GetTextSize(v.Text)
		if maxf < W then maxf=W	end //look there is a text larger than our larger text,what the hell?
		if maxb < H then maxb=H	end
	end
	//since we have a large text,modify the Rounded box
	BOX_W=maxf+20
	BOX_H=(maxb*2)*(#TextTable/2)
	POS_Y=(ScrH()-BOX_H)-100
	
	draw.RoundedBox(6,POS_X,POS_Y, BOX_W,BOX_H,Color(0, 0, 0, 76))
	
		for i,v in pairs(TextTable) do
			if v.Time < CurTime() then table.remove(TextTable,i) end//ohoh,we have an expired entry,REMOVE IT
			draw.SimpleText(v.Text, FONTNAME,POS_X+10,POS_Y+maxb*(i-1),PL_COLOR, 0,0)//draw the entry!
		end
end
hook.Add( "HUDPaint", "HevDrawDamageLog", HevDrawDamageLog)